package eu.ztsh.wymiana.util;

import eu.ztsh.wymiana.data.entity.CurrencyEntity;
import eu.ztsh.wymiana.model.Currency;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class CurrencyMapper {

    public static Currency entityToPojo(CurrencyEntity entity) {
        return new Currency(entity.getSymbol(), entity.getAmount());
    }

    public static Map<String, Currency> entitiesToPojoMap(List<CurrencyEntity> values) {
        return values.stream().map(CurrencyMapper::entityToPojo)
            .collect(Collectors.toMap(Currency::symbol, pojo -> pojo));
    }

    private CurrencyMapper() {
    }

}
