package eu.ztsh.wymiana.validation;

import jakarta.validation.Validator;

public class InstanceValidator {

    private final Validator validator;

    public InstanceValidator(Validator validator) {
        this.validator = validator;
    }

    public <T> void validate(T t, Class<?>... classes) {
        var violations = validator.validate(t, classes);
        if (!violations.isEmpty()) {
            throw new ValidationFailedException(violations);
        }
    }

}
