package eu.ztsh.wymiana.validation;

import jakarta.validation.ConstraintViolation;
import lombok.Getter;

import java.util.Set;
import java.util.stream.Collectors;

@Getter
public class ValidationFailedException extends RuntimeException {

    private final transient Set<?> violations;

    public <T> ValidationFailedException(Set<ConstraintViolation<T>> violations) {
        super("Validation failed: %s".formatted(violations.stream()
            .map(ConstraintViolation::getMessage).collect(Collectors.joining(System.lineSeparator()))));
        this.violations = violations;
    }

}
