package eu.ztsh.wymiana.util;

import eu.ztsh.wymiana.EntityCreator;
import eu.ztsh.wymiana.model.Currency;
import eu.ztsh.wymiana.model.User;
import org.junit.jupiter.api.Test;

import java.util.Map;

import static org.assertj.core.api.Assertions.assertThat;

class UserMapperTest {

    @Test
    void entityToPojoTest() {
        var entity = EntityCreator.user().build();
        var expected = new User(
                EntityCreator.Constants.NAME,
                EntityCreator.Constants.SURNAME,
                EntityCreator.Constants.PESEL,
                Map.of("PLN", new Currency("PLN", EntityCreator.Constants.PLN))
        );
        assertThat(UserMapper.entityToPojo(entity))
                .usingRecursiveComparison()
                .isEqualTo(expected);
    }

    @Test
    void requestToEntityTest() {
        var request = EntityCreator.userRequest().build();
        var expected = EntityCreator.user().build();
        assertThat(UserMapper.requestToEntity(request))
                .usingRecursiveComparison()
                .isEqualTo(expected);
    }

}
